/*
 * input.c
 *
 * Modified to work as client in socket based protocol
 */
#include "copyright.h"

#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#ifdef hpux
#include <time.h>
#else hpux
#include <sys/time.h>
#endif hpux
#include <signal.h>
#include <errno.h>
#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

initkeymap()
{
    char *str;

    if ((str = getdefault("keymap")) != NULL) {
	while (*str!='\0') {
	    if (*str >= 32 && *str < 127) {
		mystats->st_keymap[*str - 32]= *(str+1);
	    }
	    str+=2;
	}
    }
}

initinput()
{
    /* Nothing doing... */
}

input()
{
    W_Event data;
    int fd;

    while (1) {
	while (!W_EventsPending()) {
	    /* Screw it.  It we can't get any damned socket to block on, 
	     *   we will just poll, and blow away the cpu.  Its this systems
	     *   damned fault because no socket was provided.
	     */
	    if (W_Socket() != -1) {
		fd = ((1 << W_Socket()) | (1 << sock));
		select(32, &fd, 0, 0, 0);
	    }
	    intrupt();
	    if (isServerDead()) {
		printf("Whoops!  We've been ghostbusted!\n");
		printf("Pray for a miracle!\n");
		connectToServer(nextSocket);
		printf("Yea!  We've been resurrected!\n");
	    }
	}
	W_NextEvent(&data);
	switch ((int) data.type) {
	    case W_EV_KEY:
		if (data.Window==optionWin)
		    optionaction(&data);
		else if (data.Window == messagew) 
		    smessage(data.key);
		else 
		    keyaction(&data);
		break;
	    case W_EV_BUTTON:
		if (data.Window == war) 
		    waraction(&data);
		else if (data.Window == optionWin) 
		    optionaction(&data);
	        else buttonaction(&data);
		break;
	    case W_EV_EXPOSE:
		if (data.Window == statwin)
		    redrawStats();
		else if (data.Window == tstatw)
		    redrawTstats();
		else if (data.Window == mapw)
		    redrawall = 1;
		else if (data.Window == iconWin)
		    drawIcon();
		else if (data.Window == helpWin)
		    fillhelp();
		else if (data.Window == playerw) 
		    playerlist();
		else if (data.Window == planetw)
		    planetlist();
		else if (data.Window == rankw) 
		    ranklist();
		else if (data.Window == warnw) 
                    W_ClearWindow(warnw);
                else if (data.Window == messagew)
                    W_ClearWindow(messagew);
		break;
	    default:
		break;
	}
    }
}

keyaction(data)
W_Event *data;
{
    unsigned char course;
    struct obtype *gettarget(), *target;
    char key=data->key;

    if (data->Window!=mapw && data->Window!=w && data->Window!=infow) return;
    if (!index("sbogadc", key) || !(localflags & PFREFIT)) {
	if (key >= 32 && key < 127) {
	    key=mystats->st_keymap[key - 32];
	}
    }
    switch(key) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	    set_speed(key - '0');
	    localflags &= ~(PFREFIT);
	    break;
	case 'e': /* Turn off docking permission, eject docked vessels. */
	    if (me->p_flags & PFDOCKOK)
		sendDockingReq(0);
	    else
		sendDockingReq(1);
	    break;
	case 'r':
	    localflags |= PFREFIT;
	    warning("s=scout, d=destroyer, c=cruiser, b=battleship, a=assault, o=starbase/outpost");
	    break;
	case ')':
	    set_speed(10);
	    localflags &= ~(PFREFIT);
	    break;
	case '!':
	    set_speed(11);
	    localflags &= ~(PFREFIT);
	    break;
	case '@':
	    set_speed(12);
	    localflags &= ~(PFREFIT);
	    break;
	case '#':
	    set_speed(me->p_ship.s_maxspeed/2);
	    localflags &= ~(PFREFIT);
	    break;
	case '%':
	    set_speed(99);	/* Max speed... */
	    localflags &= ~(PFREFIT);
	    break;
	case 'a':
	    if (localflags & PFREFIT) {
		do_refit(ASSAULT);
	    }
	    break;
	case 'k': /* k = set course */
	    course = getcourse(data->Window, data->x, data->y);
	    set_course(course);
	    me->p_flags &= ~(PFPLOCK | PFPLLOCK);
	    localflags &= ~(PFREFIT);
	    break;
	case 'p': /* p = fire phasers */
	    course = getcourse(data->Window, data->x, data->y);
	    sendPhaserReq(course);
	    break;
	case 't': /* t = launch torps */
	    course = getcourse(data->Window, data->x, data->y);
	    sendTorpReq(course);
	    break;
	case 'f': 
	    /* f = launch plasma torpedos */
	    course = getcourse(data->Window, data->x, data->y);
	    sendPlasmaReq(course);
	    break;
	case 'd': /* d = detonate other torps */
	    if (localflags & PFREFIT)
		do_refit(DESTROYER);
	    else
		sendDetonateReq();
	    break;
	case 'D': /* D = detonate my torps */
	    detmine();
	    break;
	case '[':
	    shield_down();
	    break;
	case ']':
	    shield_up();
	    break;
	case 'u': /* u = toggle shields */
	    shield_tog();
	    break;
	case 's': /* For Serge */
	    if (localflags & PFREFIT)
		do_refit(SCOUT);
	    else
		shield_tog();
	    break;
	case 'b': /* b = bomb planet */
	    if (localflags & PFREFIT)
		do_refit(BATTLESHIP);
	    else
		bomb_planet();
	    break;
	case 'z': /* z = beam up */
	    beam_up();
	    break;
	case 'x': /* x = beam down */
	    beam_down();
	    break;
	case 'R': /* R = Go into repair mode */
	    sendRepairReq(1);
	    break;
	case 'y':
	case 'T':
	    if (me->p_flags & (PFTRACT | PFPRESS)) {
		sendTractorReq(0, me->p_no);
		break;
	    }
	    target = gettarget(data->Window, data->x, data->y, TARG_PLAYER);
	    if (key=='T') {
		sendTractorReq(1, target->o_num);
	    } else {
		sendRepressReq(1, target->o_num);
	    }
	    break;
	case 'o': /* o = dock at nearby starbase or orbit nearest planet */
	    if (localflags & PFREFIT) {
		do_refit(STARBASE);
	    } else {
		sendOrbitReq(1);
	    }
	    break;
	case 'O': /* O = options Window */
	    if (optionWin!=NULL && W_IsMapped(optionWin))
		optiondone();
	    else
		optionwindow();
	    break;
	case 'Q':
	    sendQuitReq();
	    break;
	case 'V':
	    showlocal++;
	    if (showlocal==3) showlocal=0;
	    break;
	case 'B':
	    showgalactic++;
	    if (showgalactic==3) showgalactic=0;
	    redrawall=1;
	    break;
	case '?': /* ? = Redisplay all message windows */
	    if (!W_IsMapped(reviewWin)) {
		if (W_IsMapped(messwa)) {
		    W_UnmapWindow(messwa);
		    W_UnmapWindow(messwt);
		    W_UnmapWindow(messwi);
		    W_UnmapWindow(messwk);
		} else {
		    W_MapWindow(reviewWin);
		}
	    } else {
		W_UnmapWindow(reviewWin);
		W_MapWindow(messwa);
		W_MapWindow(messwt);
		W_MapWindow(messwi);
		W_MapWindow(messwk);
    	    }
	    if (optionWin) {
		optionredrawtarget(reviewWin);
		optionredrawtarget(messwa);
		optionredrawtarget(messwt);
		optionredrawtarget(messwi);
		optionredrawtarget(messwk);
	    }
	    break;
	case 'c': /* c = cloak */
	    if (localflags & PFREFIT)
		do_refit(CRUISER);
	    else
		cloak();
	    break;
	case 'C': /* C = coups */
	    sendCoupReq();
	    break;
	case 'l': /* l = lock onto */
	    target = gettarget(data->Window, data->x, data->y,
		TARG_PLAYER|TARG_PLANET);
	    if (target->o_type == PLAYERTYPE) {
		sendPlaylockReq(target->o_num);
	    }
	    else { 	/* It's a planet */
		sendPlanlockReq(target->o_num);
	    }
	    break;
	case '*':
	    sendPractrReq();
	    break;
	/* Start of display functions */
	case ' ': /* ' ' = clear special windows */
	    W_UnmapWindow(planetw);
	    W_UnmapWindow(rankw);
	    if (infomapped)
		destroyInfo();
	    W_UnmapWindow(helpWin);
	    W_UnmapWindow(war);
	    if (optionWin)
		optiondone();
	    break;
	case 'E':    /* E = send emergency call */
	    emergency();
	    break;
	case 'L': /* L = Player list */
	    if (W_IsMapped(playerw)) {
		W_UnmapWindow(playerw);
	    } else {
		W_MapWindow(playerw);
	    }
	    break;
	case 'P': /* P = Planet list */
	    if (W_IsMapped(planetw)) {
		W_UnmapWindow(planetw);
	    } else {
		W_MapWindow(planetw);
	    }
	    break;
	case 'U': /* U = Rank list */
	    if (W_IsMapped(rankw)) {
		W_UnmapWindow(rankw);
	    } else {
		W_MapWindow(rankw);
	    }
	    break;
	case 'S': /* S = toggle stat mode */
	   if (W_IsMapped(statwin)) {
		W_UnmapWindow(statwin);
	   } else {
		W_MapWindow(statwin);
	   }
	   break;
	case 'M': /* M = Toggle Map mode */
	    mapmode = !mapmode;
	    if (optionWin)
		optionredrawoption(&mapmode);
	    break;
	case 'N': /* N = Toggle Name mode */
	    namemode = !namemode;
	    if (optionWin)
		optionredrawoption(&namemode);
	    break;
	case 'i': /* i = get information */
	case 'I': /* I = get extended information */
	    if (!infomapped)
		inform(data->Window, data->x, data->y, key);
	    else
		destroyInfo();
	    break;
	case 'h': /* h = Map help window */
	    if (W_IsMapped(helpWin)) {
		W_UnmapWindow(helpWin);
	    } else {
		W_MapWindow(helpWin);
	    }
	    if (optionWin)
		optionredrawtarget(helpWin);
	    break;
	case 'w': /* w = map war stuff */
	    if (W_IsMapped(war))
		W_UnmapWindow(war);
	    else
		warwindow();
	    break;
	default:
	    W_Beep();
	    break;
    }
}

buttonaction(data)
W_Event *data;
{
    unsigned char course;
    struct obtype *gettarget();

    if (data->Window!=w && data->Window!=mapw) return;
    if (data->key==W_RBUTTON) {
	course = getcourse(data->Window, data->x, data->y);
	set_course(course);
    }
    else if (data->key==W_LBUTTON) {
	course = getcourse(data->Window, data->x, data->y);
	sendTorpReq(course);
    }
    else if (data->key=W_MBUTTON) {
	course = getcourse(data->Window, data->x, data->y);
	sendPhaserReq(course);
    }
}

getcourse(ww, x, y)
W_Window ww;
int x, y;
{
    if (ww == mapw) {
	int	me_x, me_y;

	me_x = me->p_x * WINSIDE / GWIDTH;
	me_y = me->p_y * WINSIDE / GWIDTH;
	return((unsigned char) (atan2((double) (x - me_x),
	    (double) (me_y - y)) / 3.14159 * 128.));
    }
    else
	return((unsigned char) (atan2((double) (x - WINSIDE/2),
	    (double) (WINSIDE/2 - y))
		/ 3.14159 * 128.));
}

