/* 
 * getname.c
 *
 * Kevin Smith 09/28/88
 *
 */
#include "copyright2.h"

#include <stdio.h>
#include <fcntl.h>		/* ATM: this was missing */
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/time.h>
#include <errno.h>
#include <pwd.h>
#include <string.h>
#include <ctype.h>
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"
long time();
char *crypt();

getname()
/* Let person identify themselves from w */
{
    *(me->p_name)=0;
    while (*(me->p_name)==0) {
	handleLogin();
    }
}

handleLogin()
{
    static struct statentry player;
    static int position= -1;
    int plfd;
    int i;
    int entries;
    struct stat buf;

    *namePick='\0';
    inputMask=CP_LOGIN;
    while (*namePick=='\0') {
	/* Been ghostbusted? */
	if (me->p_status==PFREE) exitGame();
	if (isClientDead()) exitGame();
	socketPause();
	readFromClient();
    }

    if (strcmp(namePick, "Guest")==0 || strcmp(namePick, "guest")==0) {
	hourratio=5;
	bzero(&player.stats, sizeof(struct stats));
	player.stats.st_tticks = 1;
	player.stats.st_flags=ST_MAPMODE+ST_NAMEMODE+ST_SHOWSHIELDS+
	    ST_KEEPPEACE+ST_SHOWLOCAL*2+ST_SHOWGLOBAL*2;
	for (i=0; i<95; i++) {
	    player.stats.st_keymap[i]=i+32;
	}
	player.stats.st_keymap[95]=0;
	/* If this is a query on Guest, the client is screwed, but 
	 * I'll send him some crud anyway. 
	 */
	if (passPick[15]!=0) {
	    sendClientLogin(&player.stats);
	    flushSockBuf();
	    return;
	}
	sendClientLogin(&player.stats);
	flushSockBuf();
	strcpy(me->p_name, namePick);
	me->p_pos= -1;
	bcopy(&player.stats, &(me->p_stats), sizeof(struct stats));
	return;
    }
    hourratio=1;

    /* We look for the guy in the stat file */
    if (strcmp(player.name, namePick) != 0) {
	for (;;) {	/* so I can use break; */
	    plfd = open(PLAYERFILE, O_RDONLY, 0644);
	    if (plfd < 0) {
		printf("I cannot open the player file!\n");
		strcpy(player.name, namePick);
		position= -1;
		break;
	    }
	    position=0;
	    while (read(plfd, (char *) &player, sizeof(struct statentry)) ==
		    sizeof(struct statentry)) {
		if (strcmp(namePick, player.name)==0) {
		    close(plfd);
		    break;
		}
		position++;
	    }
	    if (strcmp(namePick, player.name)==0) break;
	    close(plfd);
	    position= -1;
	    strcpy(player.name, namePick);
	    break;
	}
    } 

    /* Was this just a query? */
    if (passPick[15]!=0) {
	if (position== -1) {
	    sendClientLogin(NULL);
	} else {
	    sendClientLogin(&player.stats);
	}
	flushSockBuf();
	return;
    } 

    /* A new guy? */
    if (position== -1) {
	strcpy(player.name, namePick);
	strcpy(player.password, crypt(passPick, namePick));
	bzero(&player.stats, sizeof(struct stats));
	player.stats.st_tticks = 1;
	player.stats.st_flags=ST_MAPMODE+ST_NAMEMODE+ST_SHOWSHIELDS+
	    ST_KEEPPEACE+ST_SHOWLOCAL*2+ST_SHOWGLOBAL*2;
	for (i=0; i<95; i++) {
	    player.stats.st_keymap[i]=i+32;
	}
	plfd = open(PLAYERFILE, O_RDWR|O_CREAT, 0644);
	if (plfd < 0) {
	    sendClientLogin(NULL);
	} else {
	    fstat(plfd, &buf);
	    entries = buf.st_size / sizeof(struct statentry);
	    lseek(plfd, (off_t)(entries * sizeof(struct statentry)), 0); /*ATM*/
	    write(plfd, (char *) &player, sizeof(struct statentry));
	    close(plfd);
	    me->p_pos = entries;
	    bcopy(&player.stats, &(me->p_stats), sizeof(struct stats));
	    strcpy(me->p_name, namePick);
	    sendClientLogin(&player.stats);
	}
	flushSockBuf();
	return;
    }

    /* An actual login attempt */
    if (strcmp(player.password, crypt(passPick, player.password)) != 0) {
	sendClientLogin(NULL);
    } else {
	sendClientLogin(&player.stats);
	strcpy(me->p_name, namePick);
	me->p_pos=position;
	bcopy(&player.stats, &(me->p_stats), sizeof(struct stats));
    }
    flushSockBuf();
    return;
}

savestats()
{
    int fd;

    if (me->p_pos < 0) return;
    fd = open(PLAYERFILE, O_WRONLY, 0644);
    if (fd >= 0) {
	me->p_stats.st_lastlogin = time(NULL);
	lseek(fd, (off_t)(32 + me->p_pos * sizeof(struct statentry)) ,0);/*ATM*/
	write(fd, (char *) &me->p_stats, sizeof(struct stats));
	close(fd);
    }
}
