/*
 * phaser.c
 */
#include "copyright.h"

#include <stdio.h>
#include <math.h>
#include <signal.h>
#include "defs.h"
#include "struct.h"
#include "data.h"

phaser(course)
unsigned char course;
{
    register int i;
    register struct player *j, *target;
    register struct plasmatorp *target2;
    register struct plasmatorp *k;
    register struct phaser *mine;
    int whichtarget;
    int target_x, target_y;
    unsigned char dir;
    int range, trange;
    int maxangle;
    int myphrange;
    char buf[80];

    mine = &phasers[me->p_no];

    if (myship->s_phasercost < 0) {
	warning("Weapons Officer:  This ship is not armed with phasers, captain!");
	return;
    }
    if (mine->ph_status != PHFREE) {
	warning("Phasers have not recharged");
	return;
    }
    if (me->p_fuel < myship->s_phasercost) {
	warning("Not enough fuel for phaser");
	return;
    }
    if (me->p_flags & PFREPAIR) {
	warning("Can't fire while repairing");
	return;
    }
    if (me->p_flags & PFWEP) {
	warning("Weapons overheated");
	return;
    }
    if ((me->p_cloakphase) && (me->p_ship.s_type != ATT)) {
	warning("Cannot fire while cloaked");
	return;
    }

    me->p_fuel -= myship->s_phasercost;
    me->p_wtemp += myship->s_phasercost / 10;
    mine->ph_dir = course;

    whichtarget=0;
    range=1000000;	/* Sufficiently big. */

    for (i = 0, j = &players[i]; i < MAXPLAYER; i++, j++) {
	if ((j->p_status != PALIVE) || (j == me))
	    continue;
	if ((!((j->p_swar | j->p_hostile) & me->p_team)) &&
	    (!((me->p_swar | me->p_hostile) & j->p_team)))
		continue;
	dir = (unsigned char) (atan2((double) (j->p_x - me->p_x),
	    (double) (me->p_y - j->p_y)) / 3.14159 * 128.);
	trange = (int) hypot((double) (j->p_x - me->p_x),
	    (double) (j->p_y - me->p_y));
	if (trange==0) trange=1;
	maxangle = atan((float) EXPDIST / trange) / 3.14159 * 128.0;
	if (angdist(dir, course) <= maxangle) {
	    if (range > trange) {
		whichtarget = 1;
		target = j;
		range = trange;
	    }
	}
    }

    for (i = 0, k = &plasmatorps[i]; i < MAXPLASMA*MAXPLAYER; i++, k++) {
	if ((k->pt_status != PTMOVE) || (k->pt_owner == me->p_no))
	    continue;
	if ((!(k->pt_war & me->p_team)) &&
	    (!((me->p_swar | me->p_hostile) & k->pt_team)))
		continue;
	dir = (unsigned char) (atan2((double) (k->pt_x - me->p_x),
	    (double) (me->p_y - k->pt_y)) / 3.14159 * 128.);
	trange = (int) hypot((double) (k->pt_x - me->p_x),
	    (double) (k->pt_y - me->p_y));
	if (trange==0) trange=1;
	maxangle = atan((float) EXPDIST / 4 / trange) / 3.14159 * 128.0;
	if (angdist(dir, course) <= (maxangle+1)) {
	    if (range > trange) {
		target_x = k->pt_x;
		target_y = k->pt_y;
		whichtarget = 2;
		target2 = k;
		range = trange;
	    }
	}
    }

    mine->ph_fuse=me->p_ship.s_phaserfuse;

    myphrange = PHASEDIST * me->p_ship.s_phaserdamage / 100;

    if ((whichtarget == 0) || 
	    (range > myphrange)) {
	mine->ph_status = PHMISS;
	warning("Phaser missed!!!");
    } else if (whichtarget == 2) {
	warning("You destroyed the plasma torpedo!");
	mine->ph_x = target_x;
	mine->ph_y = target_y;
	mine->ph_status = PHHIT2;
	target2->pt_status = PTDET;
    } else {
	mine->ph_target = target->p_no;
	mine->ph_damage = me->p_ship.s_phaserdamage * 
	    (1.0 - (range / (float) myphrange));
	if (mine->ph_damage < 0) mine->ph_damage = - mine->ph_damage;
	mine->ph_status = PHHIT;
	(void) sprintf(buf, "Phaser burst hit %s for %d points",
	    target->p_name,
	    mine->ph_damage);
	warning(buf);
    }
}
