/* robotII.c
 */
#include "copyright.h"

/*#include <X/Xlib.h>*/
#include <X11/Xlib.h>		/* ATM */
#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <signal.h>
#include <setjmp.h>
#include "defs.h"
#include "struct.h"
#include "data.h"

Window mapw;				/* XXX */

struct itimerval udt;
int redrawall;
int lastm;

/* lots of neat flags (auto == init to zero) */
int hostile;
int debug;
int level;
int fleet;
int sticky;
int berserk;
int practice;
int nofuel;
int destroyer;

char *rnames[4] = { "M5", "Colossus", "Guardian", "HAL"};

main(argc, argv)
int argc;
char **argv;
{
    register int i;
    int rmove();
    int team = -1;
    int bteam;
    int pno;
    char str[80];
    char *robo_name = NULL;		/* ATM */

    for( ; argc>1 && argv[1][0]=='-'; argc--,argv++) {
	switch(argv[1][1]) {
	    case 'F':
		nofuel++;		/* no umlimited fuel */
		break;
	    case 'D':
		destroyer++;		/* ATM: fly a destroyer instead */
		break;
	    case 'f':
		fleet++;		/* allow >1 robot on a team */
		break;
	    case 's':
		sticky++;		/* not used? something with timer */
		break;
	    case 'd':
		debug++;		/* print debug messages */
		break;
	    case 'h':
		hostile++;		/* attacks other robots, invades */
		break;
	    case 'p':
		practice++;		/* practice robot */
		break;
	    case 'b':
		berserk++;		/* hostile to everybody */
		break;
	    case 'l':			/* not used? */
		if (argv[1][2] != NULL)
		    level = atoi(&argv[1][2]);
		else
		    level = 100;
		break;
	    case 'T':			/* which team */
		switch (argv[1][2]) {
		    case 'f':
			team = 0;
			bteam = FED;
			break;
		    case 'r':
			team = 1;
			bteam = ROM;
			break;
		    case 'k':
			team = 2;
			bteam = KLI;
			break;
		    case 'o':
			team = 3;
			bteam = ORI;
			break;
		    default:
			fprintf(stderr, "Unknown team type.  Usage -Tx where x is [frko]\n");
			exit(1);
		}
		break;
	    case 'n':		/* ATM */
		robo_name = &(argv[1][2]);
		break;
	    default:
		fprintf(stderr, "Unknown option '%c'\n", argv[1][1]);
		fprintf(stderr,
"Fuel, fleet, sticky, debug, hostile, practice, berserk, level, Team, name\n");
		exit(1);
	}


    }
    srandom(getpid() * time((long *) 0));
    readsysdefaults();
    if (team < 0 || team >= 4) {
	if (debug)
	    fprintf(stderr, "Choosing random team.\n");
	team = random() % 4;
    }
    if (robo_name == NULL)
	robo_name = rnames[team];		/* ATM */
    openmem();
    pno = findrslot();  /* Robots are entitled to tester's slots. */
    me = &players[pno];
    me->p_no=pno;
    myship = &me->p_ship;
    mystats = &me->p_stats;
    lastm = mctl->mc_current;
    /* At this point we have memory set up.  If we aren't a fleet, we don't
       want to replace any other robots on this team, so we'll check the
       other players and get out if there are any on our team.
    */

    if (!fleet) { 
	for (i = 0; i < MAXPLAYER; i++) {
	    if ((players[i].p_status == PALIVE) && (players[i].p_team == bteam)) {
		if (debug)
		    fprintf(stderr, "Galaxy already defended\n");
		players[pno].p_status = PFREE;
		exit(1);
	    }
	}
    }

    if (practice) {
	strcpy(pseudo, "Hoser");
    } else {
/*	strcpy(pseudo, rnames[team]);*/
	strcpy(pseudo, robo_name);
    }
    strcpy(login, "Robot");

    (void) strncpy(me->p_login, login, sizeof (me->p_login));
    me->p_login[sizeof(me->p_login) - 1] = '\0';
    (void) strncpy(me->p_monitor, "Nowhere", sizeof(me->p_monitor));
    me->p_monitor[sizeof(me->p_monitor) - 1] = '\0';
    if (destroyer)
	enter(team, "Nowhere", pno, DESTROYER);		/* ATM */
    else
	enter(team, "Nowhere", pno, BATTLESHIP);
    me->p_pos = -1;			/* So robot stats don't get saved */
    me->p_flags |= PFROBOT;			/* Mark as a robot */
    if (berserk)
	me->p_hostile = (FED|ROM|KLI|ORI);	/* unless they are berserk */
    else if (practice)
	me->p_hostile = bteam;			/* or practice */
    else
	me->p_hostile = 0;			/* robots are peaceful */

    if (practice)
	me->p_flags |= PFPRACTR;		/* Mark as a practice robot */
    sigset(SIGALRM, rmove);
    if (!nofuel) {
	myship->s_phasercost = 0;
	myship->s_torpcost = 0;
	myship->s_cloakcost = 0;
    }
    if (practice) {
	udt.it_interval.tv_sec = 1;		/* Robots get to move 1/sec */
	udt.it_interval.tv_usec = 000000;
    }
    else {
	udt.it_interval.tv_sec = 0;		/* Robots get to move 2/sec */
	udt.it_interval.tv_usec = 500000;
    }
    udt.it_value.tv_sec = 1;
    udt.it_value.tv_usec = 0;
    if (setitimer(ITIMER_REAL, &udt, 0) < 0) {
	perror("setitimer");
	me->p_status = PFREE;		/* Put robot in game */
	exit(1);
    }
    /* allows robots to be forked by the daemon -- Evil ultrix bullshit */
/*    sigsetmask(0);*/		/* ATM: no masks under UTS 2.1 */

    me->p_status = PALIVE;		/* Put robot in game */
    while (1) {
	pause();
    }
}

findrslot()
{
    register int i;

    for (i = 0; i < MAXPLAYER; i++) {
        if (players[i].p_status == PFREE) {     /* We have a free slot */
            players[i].p_status = POUTFIT;      /* possible race code */
            break;
        }
    }
    if (i == MAXPLAYER) {
        fprintf(stderr, "No more room in game\n");
        exit (0);
    }
    bzero(&players[i].p_stats, sizeof(struct stats));  
    players[i].p_stats.st_tticks=1;
    return(i);
}

warning(mess)
int mess;
{
    if (debug)
	fprintf(stderr, "warning: %s\n", mess);
}
